#include <libnet/host.h>
#include <libnet/url.h>
#include <stdlib.h>
#include <iostream>
#include <arpa/inet.h>
#include <netdb.h>

using namespace net;

char *addr_to_string( uint32 nAddress );

int main( int argc, char *argv[] )
{
	Host cHost("foo");
	std::cout << "1: Expected foo got " << cHost.GetHost().c_str() << std::endl;
	cHost.SetPort(110);
	std::cout << "2: Expected 110 got " << cHost.GetPort() << std::endl;

	Host cHost2("bar", 25);
	std::cout << "3: Expected bar:25 got " << cHost2.GetHost().c_str() << ":" << cHost2.GetPort() << std::endl;

	// Obviously if www.syllable.org moves the IP address returned will change
	Host cHost3("www.syllable.org");
	std::cout << "4: Expected 66.35.250.210 got " << addr_to_string(cHost3.GetIPAddress()->GetAddress()) << std::endl;

	Url cUrl("http://www.syllable.org:8080");
	Host cHost4(cUrl);
	std::cout << "5: Expected 66.35.250.210 got " << addr_to_string(cHost4.GetIPAddress()->GetAddress()) << std::endl;
	std::cout << "6: Expected 8080 got " << cHost4.GetPort() << std::endl;
	std::cout << "7: Expected 66.35.250.210 got " << addr_to_string(cHost4.GetIPAddress()->GetAddress()) << std::endl;

	return EXIT_SUCCESS;
}

char *addr_to_string( uint32 nAddress )
{
	struct in_addr sAddr;
	sAddr.s_addr = nAddress;
	return inet_ntoa( sAddr );
}
