    	
#include <libnet/ipaddress.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <iostream>

using namespace net;

char *addr_to_string( uint32 nAddress );

int main( int argc, char *argv[] )
{
	uint32 nAddress, nExpected;

	IPAddress cAddress("127.0.0.1");
	nExpected = cAddress.GetAddress();
	std::cout << "1: Expected 127.0.0.1, got " << addr_to_string(nExpected) << std::endl;
	if( nExpected != 16777343 )
		return EXIT_FAILURE;

	cAddress.SetAddress("192.168.0.1");
	nExpected = cAddress.GetAddress();
	std::cout << "2: Expected 192.168.0.1, got " << addr_to_string(nExpected) << std::endl;
	if( nExpected != 16820416 )
		return EXIT_FAILURE;

	nAddress = cAddress.GetAddress();
	cAddress.SetAddress("invalid");
	nExpected = cAddress.GetAddress();
	std::cout << "3: Expected 0, got " << addr_to_string(nExpected) << std::endl;
	if( nExpected != 0 )
		return EXIT_FAILURE;

	cAddress.SetAddress(nAddress);
	nExpected = cAddress.GetAddress();
	std::cout << "4: Expected 192.168.0.1, got " << addr_to_string(nExpected) << std::endl;
	if( nExpected != 16820416 )
		return EXIT_FAILURE;

	nExpected = cAddress.GetAddress();
	std::cout << "5: Expected 192.168.0.1, got " << addr_to_string(nExpected) << std::endl;
	if( nExpected != 16820416 )
		return EXIT_FAILURE;

	return 0;
}

char *addr_to_string( uint32 nAddress )
{
	struct in_addr sAddr;
	sAddr.s_addr = nAddress;
	return inet_ntoa( sAddr );
}
